<template>
  <prime-card class="project">
    <template #title>
      {{ project.name }}
    </template>
    <template #content>
      Домен: {{ project.domain }}
    </template>
    <template #footer>
      <div class="project__footer">
        <router-link :to="`/${project.id}`">
          <prime-button
            icon="pi pi-chevron-right link-btn"
            label="Перейти"
          />
        </router-link>

        <prime-button
          type="button"
          label="Опции"
          aria-haspopup="true"
          aria-controls="overlay_menu"
          @click="toggle"
        />
        <prime-menu
          id="overlay_menu"
          ref="menu"
          :model="items"
          :popup="true"
        />

        <router-link tag="prime-button" :to="`/group/${project.id}`">
          <prime-button
            icon="pi pi-chevron-right link-btn"
            label="Перейти к информации по группам"
          />
        </router-link>
      </div>

      <prime-dialog
        v-model:visible="isEditModalOpen"
        header="Редактирование проекта"
        :modal="true"
      >
        <edit-project
          :project="project"
          @close="isEditModalOpen = false"
          @update="$emit('update', $event)"
        />
      </prime-dialog>

      <prime-dialog
        v-model:visible="isEditKeywordsModalOpen"
        header="Редактирование ключевых слов"
        :modal="true"
      >
        <edit-keywords
          :project="project"
          :keywords="project.keywords"
          :keyword-groups="keywordGroups"
          @close="isEditKeywordsModalOpen = false"
          @add="updateKeyword"
          @create-relation="createRelation"
          @delete-relation="deleteRelation"
          @delete="deleteKeyword"
        />
      </prime-dialog>

      <prime-dialog
        v-model:visible="isEditCompetitorsModalOpen"
        header="Редактирование конкурентов"
        :modal="true"
      >
        <edit-competitors
          :project="project"
          :competitors="project.competitors"
          @close="isEditCompetitorsModalOpen = false"
          @add="updateCompetitor"
          @delete="deleteCompetitor"
        />
      </prime-dialog>

      <prime-dialog
        v-model:visible="isShareModalOpen"
        header="Редактирование общего доступа"
        :modal="true"
      >
        <share-project-with-user
          :project="project"
          @close="isShareModalOpen = false"
        />
      </prime-dialog>

      <prime-dialog
        v-model:visible="isKeywordGroup"
        header="Редактирование групп ключевых слов"
        :modal="true"
      >
        <edit-keyword-group
          :project="project"
          :keyword-groups="keywordGroups"
          @add="keywordGroups.push($event)"
          @delete="keywordGroups.splice($event, 1)"
          @close="isKeywordGroup = false"
        />
      </prime-dialog>
    </template>
  </prime-card>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeCard from 'primevue/card/Card.vue';
import PrimeDialog from 'primevue/dialog/Dialog.vue';
import PrimeMenu from 'primevue/menu/Menu.vue';
import { defineComponent, PropType } from 'vue';
import { getKeywordGroups } from '@/api/handler/keywords';
import { deleteProject } from '@/api/handler/projects';
import EditCompetitors from '@/components/projects/EditCompetitors.vue';
import EditKeywordGroup from '@/components/projects/EditKeywordGroup.vue';
import EditKeywords from '@/components/projects/EditKeywords.vue';
import EditProject from '@/components/projects/EditProject.vue';
import ShareProjectWithUser from '@/components/projects/ShareProjectWithUser.vue';
import { Competitor } from '@/models/competitors';
import { KeywordGroup } from '@/models/keywordGroup';
import { Keyword, KeywordRelation, KeywordRelationExtended, KeywordWithRelations } from '@/models/keywords';
import { ProjectExtended } from '@/models/projects';

interface Data {
  isEditModalOpen: boolean;
  isShareModalOpen: boolean;
  isEditKeywordsModalOpen: boolean;
  isEditCompetitorsModalOpen: boolean;
  isKeywordGroup: boolean;
  keywordGroups: KeywordGroup[];
}

export default defineComponent({
  name: 'project',
  components: {
    PrimeButton,
    PrimeCard,
    PrimeDialog,
    PrimeMenu,

    EditCompetitors,
    EditKeywords,
    EditProject,
    ShareProjectWithUser,
    EditKeywordGroup,
  },
  props: {
    project: {
      type: Object as PropType<ProjectExtended>,
      required: true,
    },
  },
  emits: ['delete', 'update'],
  data(): Data {
    return {
      isEditModalOpen: false,
      isShareModalOpen: false,
      isEditKeywordsModalOpen: false,
      isEditCompetitorsModalOpen: false,
      isKeywordGroup: false,
      keywordGroups: [],
    };
  },
  computed: {
    items() {
      return [
        {
          label: 'Редактировать',
          icon: 'pi pi-refresh',
          command: (): void => {
            this.isEditModalOpen = true;
          },
        },
        {
          label: 'Редактировать ключевые слов',
          icon: 'pi pi-refresh',
          command: (): void => {
            this.isEditKeywordsModalOpen = true;
          },
        },
        {
          label: 'Редактировать конкурентов',
          icon: 'pi pi-refresh',
          command: (): void => {
            this.isEditCompetitorsModalOpen = true;
          },
        },
        {
          label: 'Поделиться с другими пользователями',
          icon: 'pi pi-user',
          command: (): void => {
            this.isShareModalOpen = true;
          },
        },
        {
          label: 'Редактировать группы ключевых слов',
          icon: 'pi pi-user',
          command: (): void => {
            this.isKeywordGroup = true;
          },
        },
        {
          label: 'Удалить',
          icon: 'pi pi-times',
          command: (): void => {
            this.deleteConfirmation();
          },
        },
      ];
    },
  },
  async mounted() {
    const res = await getKeywordGroups({ project: this.project.id });

    if (res.__state === 'success') {
      this.keywordGroups = res.data;
    }
  },
  methods: {
    toggle(event: MouseEvent) {
      (this.$refs.menu as any).toggle(event);
    },
    save() {
      this.$toast.add({ severity: 'success', summary: 'Success', detail: 'Data Saved', life: 3000 });
    },
    deleteConfirmation() {
      this.$confirm.require({
        message: `Вы уверены, что хотите удалить проект "${this.project.name}"?`,
        header: `Удаление проекта "${this.project.name}"`,
        icon: 'pi pi-exclamation-triangle',
        accept: () => {
          this.delete();
        },
      });
    },
    updateKeyword(keyword: Keyword) {
      const project = { ...this.project };
      const keywordWithRelations: KeywordWithRelations = { ...keyword, relations: [] };
      project.keywords = [...project.keywords, keywordWithRelations];
      this.$emit('update', project);
    },
    deleteKeyword(id: Keyword['id']) {
      const index = this.project.keywords.findIndex((project) => project.id === id);

      if (index === -1) {
        return;
      }

      const project = { ...this.project };
      project.keywords = [...project.keywords];
      project.keywords.splice(index, 1);
      this.$emit('update', project);
    },
    createRelation(newRelation: KeywordRelationExtended) {
      const project = { ...this.project };
      const keyword = project.keywords.find(keywordItem => keywordItem.id === newRelation.keyword.id);
      if (keyword === undefined) {
        return;
      }
      keyword.relations = [...keyword.relations];
      keyword.relations.push(newRelation);
      this.$emit('update', project);
    },
    deleteRelation({ keyword: updateKeyword, keywordRelation }: { keyword: Keyword, keywordRelation: KeywordRelation }) {
      const project = { ...this.project };
      const keyword = project.keywords.find(keywordItem => keywordItem.id === updateKeyword.id);
      if (keyword === undefined) {
        return;
      }
      keyword.relations = [...keyword.relations];
      const relationIndex = keyword.relations.findIndex(relation => relation.id === keywordRelation.id);
      if (relationIndex === -1) {
        return;
      }
      keyword.relations.splice(relationIndex, 1);
      this.$emit('update', project);
    },
    updateCompetitor(competitor: Competitor) {
      const project = { ...this.project };
      project.competitors = [...project.competitors, competitor];
      this.$emit('update', project);
    },
    deleteCompetitor(id: Competitor['id']) {
      const index = this.project.competitors.findIndex((project) => project.id === id);

      if (index === -1) {
        return;
      }

      const project = { ...this.project };
      project.competitors = [...project.competitors];
      project.competitors.splice(index, 1);
      this.$emit('update', project);
    },
    async delete() {
      const res = await deleteProject({ id: this.project.id });
      if (res.__state === 'success') {
        this.$emit('delete');
      } else {
        this.$toast.add({ severity: 'error', detail: 'Что-то пошло не так', life: 3000 });
      }
    },
  },
});
</script>

<style lang="scss" scoped>
.project {
  width: 25rem;

  &__footer {
    & > :not(:last-child) {
      margin-right: 0.2rem;
    }

    & button {
      margin-top: 0.2rem;
    }
  }
}

a {
  text-decoration: none;
}
</style>
